(() => {
    /**
     * Check and set a global guard variable.
     * If this content script is injected into the same page again,
     * it will do nothing next time.
     */
    if (window.hasRun) {
      return;
    }
    window.hasRun = true;

    function fetch_request(url, callback){
        
        // fetching the pad
        fetch(`${url}/export/txt`, {
            'method': 'GET',
            'mode': 'cors',
        })
        .then(response => response.text() )
        .then(css => inject_css(css) );
    }

    function fetch_request_general(url, callback){
        
        // fetching the pad
        fetch(`${url}/export/txt`, {
            'method': 'GET',
            'mode': 'cors',
        })
        .then(response => response.text() )
        .then(css => inject_css_general(css) );
    }

    function inject_pagedJs () {
        let pagedJsCDN = "https://unpkg.com/pagedjs/dist/paged.polyfill.min.js";
        let el = document.createElement('script');
        el.id = "paged-js";
        el.src = pagedJsCDN;
        document.head.appendChild(el);
    }

    function inject_css(css){

        console.log('pad loaded!');

        // let etherstyle = document.getElementById('etherstyle');
        // if (etherstyle) { etherstyle.remove(); }

        // import new pad as style
        let el = document.createElement('style');
        el.id = "etherstyle";
        el.type = 'text/css';
        el.innerText = css;
        document.head.appendChild(el);

        inject_pagedJs();
        // inject_nav()

    }

    function clean_style() {
        // remove previously imported pad as style
        let styles = document.querySelectorAll('style');
        console.log(styles)
        if (styles) {
            styles.forEach(style => {
                style.remove(); 
            })
        }

        let links = document.querySelectorAll('link')
        links.forEach(link => {
            if (link.getAttribute('rel') == 'stylesheet') {
                link.remove();
            }
        })

    }

    function inject_css_general(css){

        clean_style()

        // import new pad as style
        let el = document.createElement('style');
        el.id = "etherstyle-2";
        el.type = 'text/css';
        el.innerText = css;
        document.head.appendChild(el);
    }

    function load_pad(pad){
        fetch_request(pad, inject_css);
    }

    function load_pad_general(pad){
        fetch_request_general(pad, inject_css_general);
    }

    // --- storage
    let etherpad = 'https://pads.luuse.fun/p/la-piraterie-demo';
    let etherpadGeneral = 'https://pads.luuse.fun/p/la-piraterie-general';
    browser.storage.local.get('etherpad').then(function(result){
        if(result.etherpad){
            etherpad = result.etherpad;
        }
    }).then(function(){
        console.log('loading pad', etherpad);
        load_pad_general(etherpadGeneral);
        load_pad(etherpad);
    });

    // --- update
    browser.runtime.onMessage.addListener((message) => {
        if (message.command === "etherpadchange") {
            
            new_pad = message.url;
            console.log("changing etherpad", new_pad);
            browser.storage.local.set({ "etherpad": new_pad });
            load_pad_general(etherpadGeneral);
            load_pad(new_pad);
        }
    });

})();