(() => {
    /**
     * Check and set a global guard variable.
     * If this content script is injected into the same page again,
     * it will do nothing next time.
     */
    if (window.hasRun) {
      return;
    }
    window.hasRun = true;

    function fetch_request(url, callback){
        // fetching the pad
        fetch(`${url}/export/txt`, {
            'method': 'GET',
            'mode': 'cors',
        })
        .then(response => response.text() )
        .then(css => inject_css(css) );
    }

    function inject_pagedJs () {
        let pagedJsCDN = "https://unpkg.com/pagedjs/dist/paged.polyfill.min.js";
        let el = document.createElement('script');
        el.id = "paged-js";
        el.src = pagedJsCDN;
        document.head.appendChild(el);
    }

    function inject_css(css){

        console.log('pad loaded!');

        // remove previously imported pad as style
        let style = document.querySelector('style');
        if (style) {
            style.remove(); 
        }

        // let etherstyle = document.getElementById('etherstyle');
        // if (etherstyle) { etherstyle.remove(); }

        // import new pad as style
        let el = document.createElement('style');
        el.id = "etherstyle";
        el.type = 'text/css';
        el.innerText = css;
        document.head.appendChild(el);

        inject_pagedJs();
        // inject_nav()

        let everything = document.querySelectorAll('*');
        for(thing of everything){
            thing.setAttribute('tabindex', '0');
        }
    };

    function inject_nav() {
        let nav = document.createElement('div');
        nav.textContent = 'coucou';
        document.body.appendChild(nav);
        console.log(nav)
    }

    function load_pad(pad){
        fetch_request(pad, inject_css);
    }

    // --- storage
    let etherpad = 'https://pads.luuse.fun/p/la-piraterie-demo';
    browser.storage.local.get('etherpad').then(function(result){
        if(result.etherpad){
            etherpad = result.etherpad;
        }
    }).then(function(){
        console.log('loading pad', etherpad);
        load_pad(etherpad);
    });

    // --- update
    browser.runtime.onMessage.addListener((message) => {
        if (message.command === "etherpadchange") {
            
            new_pad = message.url;
            console.log("changing etherpad", new_pad);
            browser.storage.local.set({ "etherpad": new_pad });
            load_pad(new_pad);
        }
    });

})();